class Searchmatcher
  def initialize(klass, options)
    @field = options.keys.first.to_s
    @value = options.values.first
    @klass = klass
  end

  def results
     klass.where(formater, search: "#{value}%")
  end

  def formater
    return {} if field.nil? || field.blank?
    field.split("_or_").map { |f| f  + " LIKE :search" }.join(" OR ")
  end

  attr_accessor :field, :value, :klass
end

#should pass the className and fields with value as hash
# example 1
# @jobs = Searchmatcher.new(Job, {name: "software"}).results
# example 2
# @jobs = Searchmatcher.new(Job, {title_or_description: "software"}).results

# form can be a controller add specific page controller or actions inside the form_tag
#<%= form_tag("/jobs", method: "get") do %>
# <%= label_tag(:title_or_description, "Search for:") %>
# <%= text_field_tag "search[title_or_description]" %>
# <%= submit_tag("Search") %>
#<% end %>

#get the params
# @jobs = Searchmatcher.new(Job, params["search"]).results
